/**
 * @class
 * Umožňuje přehrávat jeden zvuk vícekrát současně
 */
class Sound {
    /**
     * @param {string} path cesta ke zvukovému souboru
     */
    constructor(path) {
        this.sounds = [];
        this.path = path;
        this.sounds.push(new Audio(path));
        this.vol = 1;
    }

    /**
     * přehraje zvuk
     */
    play() {
        let soundPlayed = false;
        for (let sound of this.sounds) {
            if (sound.paused) {
                sound.play();
                soundPlayed = true;
                break;
            }
        }

        if (!soundPlayed) {
            let newAudio = new Audio(this.path);
            newAudio.volume = this.vol;
            this.sounds.push(newAudio);
            this.sounds[this.sounds.length-1].play();
        }
    }

    /**
     * hlasitost zvuku
     */
    set volume(vol) {
        this.vol = vol;
        for (let sound of this.sounds) {
            sound.volume = vol;
        }
    }

    get volume() {
        return this.vol;
    }
}